(** Utilitaires Boggle:
  * lecture et écriture de grilles, fonction de score...
  * Pour traiter les grilles avec inconnues, les fonctions
  * d'affichage prennent en arg une fonction d'affichage. *)

let parse () =
  let line = input_line stdin in
  let n = String.length line in
    if n <= 0 then failwith "Incorrect input!" ;
    let rec lines remaining =
      if remaining = 0 then [] else
        let line = input_line stdin in
          if String.length line <> n then failwith "Incorrect input!" ;
          line :: lines (remaining-1)
  in
    let lines = line :: lines (n-1) in
      Array.of_list
        (List.map (fun s -> Array.init n (fun i -> s.[i])) lines)

let print ~to_char b =
  for i = 0 to Array.length b - 1 do
    for j = 0 to Array.length b - 1 do
      Format.print_char (to_char b.(i).(j))
    done ;
    Format.print_newline ()
  done

let word_of_path ~to_char board p =
  let n = List.length p in
  let w = String.make n '?' in
  let rec aux k = function
    | [] -> ()
    | (i,j)::tl -> w.[n-k-1] <- to_char board.(i-1).(j-1) ; aux (k+1) tl
  in
    aux 0 p ;
    w

let score_of_word w =
  match String.length w with
    | 0 | 1 | 2 -> 0
    | 3 | 4 -> 1
    | 5 -> 2
    | 6 -> 3
    | 7 -> 5
    | _ -> 11
