(** Compile une liste de mots passée sur stdin
  * en un trie, et le sérialise dans un fichier passé
  * sur la ligne de commande. *)

let rec add_lines n t =
  match
    try Some (input_line stdin) with End_of_file -> None
  with
    | Some word ->
        assert (word <> "") ;
        add_lines (n+1) (Trie.add word t)
    | None ->
        Printf.printf "Lines read:\t%d\n" n ;
        Printf.printf "Words in trie:\t%d\n" (Trie.size t) ;
        if Array.length Sys.argv > 1 then
          let filename = Sys.argv.(1) in
            Printf.printf "Saving to %S...\n" filename ;
            Trie.save ~filename t

let () = add_lines 0 Trie.empty
