(** Usage: generator [n] [v] [d]
  * Tous les arguments sont optionnels
  *  - n: taille de la grille
  *  - v: nombre de variables
  *  - d: densité des variables *)

open Scrabble

let n =
  try int_of_string Sys.argv.(1) with _ -> 4

let vars =
  try int_of_string Sys.argv.(2) with _ -> 0

let var_density =
  try float_of_string Sys.argv.(3) with _ -> if vars = 0 then 0. else 0.1

let () =
  begin try
    Random.init (int_of_string (Sys.getenv "SEED"))
  with _ ->
    Random.self_init ()
  end ;
  for i = 1 to n do
    for j = 1 to n do
      if Random.float 1. >= var_density then
        print_char (Char.lowercase (random_char ()))
      else
        print_char (char_of_int (int_of_char 'A' + Random.int vars))
    done ;
    print_newline ()
  done
