(** French scrabble distribution according to Wikipedia.
  * Letters are grouped per points: 1; 2, 3, 4, 8, 10. *)
let distribution = [
  'E',15; 'A',9; 'I',8; 'N',6; 'O',6; 'R',6; 'S',6; 'T',6; 'U',6; 'L',5;
  'D',3; 'M',3; 'G',2;
  'B',2; 'C',2; 'P',2;
  'F',2; 'H',2; 'V',2;
  'J',1; 'Q',1;
  'K',1; 'W',1; 'X',1; 'Y',1; 'Z',1 ]

let total = List.fold_left (+) 0 (List.map snd distribution)

let random_char () =
  let rec select n = function
    | (a,k) :: l ->
        if n<k then a else select (n-k) l
    | [] -> assert false
  in
    select (Random.int total) distribution
